# Backbone-Server

Backbone-Server creates a Server module which pulls together Backbone and Express to bring greater structure to your
NodeJS applications.

Backbone.Server can be accessed just like any other Backbone module:

```
var Backbone = require('backbone-server'); // Note: Backbone-Server relies on the backbone npm package and is not required.

// Current defaults for Backbone.Server
var server = new Backbone.Server(
    'port'         : 8000,
    'public'       : 'public',      // The Public Director
    'views'        : 'views',       // The Views Director
    'view-engine'  : 'jade',        // Desired Templating Engine
    'routes'       : {},            // Any initial routes you may have (or create them all at once)
});
```

And of course, you can always extend it in traditional Backbone form:

```
var Blog = Backbone.Server.extend({

    // Custom features can go here

});
``

## Routes

Once you have added a Server, add routes just as you would with Express:

```
server.get('/post/:id', function(req, res) {
    var id = req.params.id,
        article = articles.get(id);
    
    res.render('single', article);
});

server.post('/post', function(req, res) {
    articles.add(req.params);
});

server.put('/post/:id', function(req, res) {
    var article = article.get(req.params.id);
    
    article.set(req.params);
});

server.delete('/post/:id', function(req, res) {
    articles.remove(params.req.id);    
});

```
## Starting the Server:

Once you have created a server starting it is easy:

`server.start();`

## Don't see something here you like from Express?

Target Express directly:

`server.app // === Express `